<?php
// Include the main TCPDF library (search for installation path).
function NEXForms_export_to_PDF($entry_ID, $save=false, $ajax=false, $attach=false){
	
	
	$nf_functions = new NEXForms_Functions();
	$database_actions = new NEXForms_Database_Actions();
	if(!$save)
		{
		$parse_uri = explode( 'wp-content', $_SERVER['SCRIPT_FILENAME'] );
		require_once( $parse_uri[0] . 'wp-load.php' );
		require_once('tcpdf_include.php');
		}

// create new PDF document
$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);


	global $wpdb;
	global $current_user;
	$form_entry = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms_entries WHERE Id="'.$entry_ID.'"');
	$form_attr = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id="'.$form_entry->nex_forms_Id.'"');

// set document information
/*$pdf->SetCreator($database_actions->get_username($form_entry->user_Id));
$pdf->SetAuthor($database_actions->get_username($form_entry->user_Id));
$pdf->SetTitle($database_actions->get_title($form_entry->nex_forms_Id,'wap_nex_forms'));
$pdf->SetSubject();
$pdf->SetKeywords();*/


$date_time = explode(' ',$form_entry->date_time);

$date = explode('-', $date_time[0]);
$time = explode(':', $date_time[1]);

/*$set_header = 'Submitted by '.(($database_actions->get_username($form_entry->user_Id)) ? $database_actions->get_username($form_entry->user_Id) : 'Guest').' '.(($form_entry->date_time) ? 'on '.date(get_option('date_format'),mktime($time[0],$time[1],$time[2],$date[1],$date[3],$date[0])) : '');
$set_header .= '
From page: '.$form_entry->page;
$set_header .= '
From IP: '.$form_entry->ip;*/
// set default header data
//$pdf->SetHeaderData('', '0', $database_actions->get_title($form_entry->nex_forms_Id,'wap_nex_forms').'', $set_header);

// set header and footer fonts
//$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
//$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// set margins
//$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
//$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
//$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// set auto page breaks
//$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// set image scale factor
//$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

// set some language-dependent strings (optional)
/*if (@file_exists(dirname(__FILE__).'/lang/pol.php')) {
	require_once(dirname(__FILE__).'/lang/pol.php');
	$pdf->setLanguageArray($l);
}*/

// ---------------------------------------------------------

// set font

$pdf->SetFont('freesans','',11);
//$pdf->SetFont('aealarabiya','',11);

$pdf->SetPrintHeader(false);
$pdf->SetPrintFooter(false);

//$pdf->SetFont('nanumbarungothicyethangul','',10);

// add a page
$pdf->AddPage();

		$upload_path = wp_upload_dir();
		$set_uploads_dir = $upload_path['path'];

			  $form_data = json_decode($form_entry->form_data);

			   $data_val_array = array();
			   foreach($form_data as $data)
					{
					if(!is_array($data->field_value) && !is_object($data->field_value))
						$data_val_array[$data->field_name]= rtrim(str_replace(',',';', $data->field_value));
					else
						$data_val_array[$data->field_name]= $data->field_value;	
					}
			
			 /* echo '<pre>';
			  print_r($form_data);
			 echo '</pre>';*/
			
			 $html = '<table width="100%" cellpadding="3" cellspacing="0">';
			 
			 $img_ext_array = array('jpg','jpeg','png','tiff','gif','psd');
			 $sigs_array = array();
			 $i = 0;
			 foreach($form_data as $data)
					{
						if($data->field_name!='paypal_invoice')
							{
							$html .= '<tr>';
								$html .= '<td width="30%"><strong>'.$nf_functions->unformat_name($data->field_name).'</strong></td>';
								$html .= '<td width="2%"><strong>:</strong></td>';
								$html .= '<td width="68%">';
									
								
									if((is_array($data->field_value) || is_object($data->field_value)) )
												{
												if($data->field_name!='')
													{
													$i = 1;
														$html .= '<table width="100%" class="highlight" cellpadding="10" cellspacing="0" style="border-bottom:1px solid #ddd; border-left:1px solid #ddd; border-top:1px solid #ddd;">';
															
														foreach($data->field_value as $key=>$val)
															{
																	
															if(is_array($val) || is_object($val))
																{
																if($i==1)
																	{
																	$html .= '<tr>';
																	foreach($val as $innerkey=>$innervalue)
																		{
																		if(!strstr($innerkey,'real_val__'))	
																			$html .= '<td style="border-bottom:1px solid #ddd;border-right:1px solid #ddd;"><strong>'.$nf_functions->unformat_name($innerkey).'</strong></td>';
																		}
																	$html .= '</tr>';
																	}
																$html .= '<tr>';
																foreach($val as $innerkey=>$innervalue)
																	{
																	if(array_key_exists('real_val__'.$innerkey.'',$val))
																			{
																			$realval = 'real_val__'.$innerkey;
																			$innervalue = $val->$realval;	
																			
																			}
																	if(!strstr($innerkey,'real_val__'))
																		{
																	
																		if($edit_entry)
																			{
																			$html .= '<td style="border-right:1px solid #ddd;border-bottom:1px solid #eee;">';
																			$html .= '<input name="'.$data->field_name.'['.$i.']['.$innerkey.']" id="'.$innerkey.'" type="text" value="'.rtrim($innervalue,', ').'">';
																			$html .= '</td>';
																			}
																		else
																			{
																			if(in_array($nf_functions->get_ext($innervalue),$img_ext_array))
																				$html .= '<td style="border-right:1px solid #ddd;border-bottom:1px solid #eee;"><img class="materialboxed" src="'.rtrim($innervalue,', ').'" /></td>';
																			else
																				$html .= '<td style="border-right:1px solid #ddd;border-bottom:1px solid #eee;">'.rtrim($innervalue,', ').'</td>';
																			}
																		}
																	}
																$html .= '</tr>';
																}
															else
																{
																if($edit_entry)
																	{
																	$html .= '<input name="'.$data->field_name.'[]" type="text" id="'.$val.'" value="'.rtrim($val,', ').'" />';
																	}
																else
																	{	
																	$html .= rtrim($val,', ').'<br />';
																	}
																}
															$i++;	
															}
													$html .= '</table>';	
													}
												
												}
									
									else
										{
										if(strstr($data->field_value,'data:image'))
											{
											$signature = str_replace('data:image/png;base64,','',$data->field_value);
											$signature = str_replace('data:image/png;base64;','',$signature);
											$sig_rand = rand(0,99999);
											file_put_contents (plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png', base64_decode($signature));
												
											$html .= '<img width="200px" src="'.plugins_url('/tmp/sig'.$sig_rand.'.png',dirname(__FILE__)).'">';
											//$html .= $data->field_value;
											
											//$html .= ;
											$sigs_array[$i] = plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png';
											$i++;
											}
										else if(in_array($nf_functions->get_ext($data->field_value),$img_ext_array))
											$html .= '<img width="200px" src="'.$data->field_value.'">';
										else
											$html .= str_replace('\\','',$data->field_value);
										}
							$html .= '</td>';
						$html .= '</tr>';
							}
							
					}
			 $html .= '</table>';
			 
			 $form_attr->pdf_html = str_replace('\\','',$form_attr->pdf_html);
			 
			 $body = str_replace('{{nf_form_data}}',$html,$form_attr->pdf_html);
			 
			 
			
			$tz = wp_timezone();
			 
			$body = str_replace('{{nf_entry_date_time}}', 		wp_date(get_option('date_format').' '.get_option('time_format'),time(), $tz) ,$body);
			$body = str_replace('{{nf_entry_date}}',			wp_date(get_option('date_format'),time(), $tz),$body);
			$body = str_replace('{{nf_entry_time}}',			wp_date(get_option('time_format'),time(), $tz),$body);
			$body = str_replace('{{nf_entry_date_year}}',		wp_date('Y',time(),$tz),$body);
			$body = str_replace('{{nf_entry_date_month}}',		wp_date('m',time(),$tz),$body);
			$body = str_replace('{{nf_entry_date_day}}',		wp_date('d',time(),$tz),$body);
			$body = str_replace('{{nf_entry_time_hour}}',		wp_date('H',time(),$tz),$body);
			$body = str_replace('{{nf_entry_time_minute}}',		wp_date('i',time(),$tz),$body);
			$body = str_replace('{{nf_entry_time_second}}',		wp_date('s',time(),$tz),$body);
			
			 
			$body = str_replace('{{nf_from_page}}',$form_entry->page,$body);
			$body = str_replace('{{nf_form_id}}',$form_attr->Id,$body);
			$body = str_replace('{{nf_entry_id}}',$entry_ID,$body);
			
			$body = str_replace('{{nf_user_ip}}',$form_entry->ip,$body);
			$body = str_replace('{{nf_form_title}}',$form_attr->title,$body);
			$body = str_replace('{{nf_user_name}}',$database_actions->get_username($form_entry->user_Id),$body);
			
			 
			
			 
			$pattern = '({{+([^}}])+}})';
			if(!$body)
			 	$body = $html;
	/*echo '<pre>';
			  print_r($form_data);
			 echo '</pre>';*/
	//$body .= '##################'.$current_user->ID;
	preg_match_all($pattern, $body, $matches);
		foreach($matches[0] as $match)
			{
			$the_val = '';
			if(is_array($data_val_array[$nf_functions->format_name($match)]))
				{
				foreach($data_val_array[$nf_functions->format_name($match)] as $thekey=>$value)
					{
					$the_val .='<span class="fa fa-check"></span> '. $value.' ';	
					}
				$the_val = str_replace('Array','',$the_val);
				$body = str_replace($match,$the_val,$body);
				}
			else if(strstr($data_val_array[$nf_functions->format_name($match)],'data:image'))
				{
				$signature = str_replace('data:image/png;base64,','',$data_val_array[$nf_functions->format_name($match)]);
				$signature = str_replace('data:image/png;base64;','',$signature);
				$sig_rand = rand(0,99999);
				file_put_contents (plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png', base64_decode($signature));
					
				$image = '<img width="200px" src="'.plugins_url('/tmp/sig'.$sig_rand.'.png',dirname(__FILE__)).'">';
				//$html .= $data->field_value;
				
				$body = str_replace($match,$image,$body);	
				
				//$html .= ;
				$sigs_array[$i] = plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png';
				$i++;
				}
			else if(strstr($data_val_array[$nf_functions->format_name($match)],',') && !strstr($data_val_array[$nf_functions->format_name($match)],'data:image'))
					{
					$is_array = explode(',',$data_val_array[$nf_functions->format_name($match)]);
					$content_ .= '<table width="100%" cellpadding="3" cellspacing="0">';
					$content_ .= '<tr>';
					foreach($is_array as $item)
						{
						if(in_array($nf_functions->get_ext($item),$img_ext_array))
							$content_ .= '<td><img  src="'.$item.'"></td>';
						}
					$content_ .= '</tr>';
					$content_ .= '</table>';
					$body = str_replace($match,$content_,$body);	
					
					}
			else
				{
				
				$body = str_replace($match,$data_val_array[$nf_functions->format_name($match)],$body);	
				
				//$body .= $nf_functions->format_name($match);
				
				//$body .= $data_val_array['seinsollte'];
				}
			}
			 
//echo $body;
// create some HTML content
$database = new NEXForms_Database_Actions();

if(class_exists('NEXForms_Conditional_Content'))
	{
	$conditional_blocks = new NEXForms_Conditional_Content();
	$body 	= $conditional_blocks->run_content_logic_blocks($body, $form_data);
	}

			
$body = ($database->checkout()) ? str_replace('\\','',$body) : 'Sorry, you need to register this plugin to export entries to PDF. Go to global settings on the dashboard and follow the registration procedure.';

$body = do_wpautop($body);

				
// output the HTML content
$pdf->writeHTML($body, true, false, false, false, '');

// reset pointer to the last page
$pdf->lastPage();

// ---------------------------------------------------------
//Close and output PDF document

foreach($sigs_array as $sigs=>$val){
	unlink($val);
	}

if($attach)
	{
	$pdf->Output($set_uploads_dir.'/'.substr($nf_functions->format_name($database_actions->get_title2($form_entry->nex_forms_Id,'wap_nex_forms')),0,10).'_'.$form_entry->Id.'.pdf', 'F');
	echo $pdf->Output($set_uploads_dir.'/'.substr($nf_functions->format_name($database_actions->get_title2($form_entry->nex_forms_Id,'wap_nex_forms')),0,10).'_'.$form_entry->Id.'.pdf', 'F');
	}
if(!$save)
	{
	$pdf->Output($nf_functions->format_name($database_actions->get_title2($form_entry->nex_forms_Id,'wap_nex_forms')).'_'.$form_entry->Id.'.pdf', 'I');
	}
else
	{
	
	if($ajax)
		{
		$pdf->Output($set_uploads_dir.'/form_entry.pdf', 'F');
		echo $upload_path['baseurl'].$upload_path['subdir'].'/form_entry.pdf';
		
		
		die();
		}
	else
		{
		$pdf->Output($set_uploads_dir.'/'.substr($nf_functions->format_name($database_actions->get_title2($form_entry->nex_forms_Id,'wap_nex_forms')),0,10).'_'.$form_entry->Id.'.pdf', 'F');
		
		//echo $set_uploads_dir.'/'.$database_actions->get_title($form_entry->nex_forms_Id,'wap_nex_forms').'_'.$form_entry->Id.'.pdf';
		
		return $set_uploads_dir.'/'.substr($nf_functions->format_name($database_actions->get_title2($form_entry->nex_forms_Id,'wap_nex_forms')),0,10).'_'.$form_entry->Id.'.pdf';
		
		//return $set_uploads_dir.'/'.$database_actions->get_title($form_entry->nex_forms_Id,'wap_nex_forms').'_'.$form_entry->Id.'.pdf';
		}
	}
}
$entry_id = (isset($_REQUEST['entry_ID'])) ? $_REQUEST['entry_ID'] : '';
if($entry_id ){
	NEXForms_export_to_PDF($entry_id , false);
}


function NEXForms_report_to_PDF(){
		
		$nf_functions = new NEXForms_Functions();
		$database_actions = new NEXForms_Database_Actions();
		
		global $wpdb;
		
		$tmp_csv_export = get_option('tmp_csv_export');
		$get_sql = explode('LIMIT',$tmp_csv_export['query']);
		$sql = $get_sql[0];
		$cols = $tmp_csv_export['cols'];
		$get_form_data = $wpdb->prepare($sql,'');
		$form_data = $wpdb->get_results($get_form_data); 
		
		$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
		$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
		if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
			require_once(dirname(__FILE__).'/lang/eng.php');
			$pdf->setLanguageArray($l);
		}
		//$pdf->SetFont('helvetica', '', 9);
		$pdf->SetFont('helvetica','',9);
		$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
			
		$page_content = array();
		
		$table_fields 	= $wpdb->get_results('SHOW FIELDS FROM '.$wpdb->prefix.'wap_nex_forms_temp_report');
		
		$header = '<h1>Submissions report for <strong>'.$database_actions->get_title($tmp_csv_export['form_Id'],'wap_nex_forms').'</strong> on '.date(get_option('date_format')).'</h1><br /><br />&nbsp;';
		$header .= '<hr>';
		$header .= '<table width="100%" cellpadding="3" cellspacing="0" border="1">';
			
			$count_cols = 1;
			$header .= '<tr>';
			foreach($table_fields as $column)
				{
				if($column->Field!='Id')
					{
					if(is_array($cols))
						{
						if(in_array($column->Field,$cols))
							{
							$columns_array[$column->Field] = $column->Field;
							$header .= '<td><strong>'.$nf_functions->unformat_name($column->Field).'</strong></td>';
							$count_cols ++;
							}
						}
					else
						{
						$columns_array[$column->Field] = $column->Field;
						$header .= '<td><strong>'.$nf_functions->unformat_name($column->Field).'</strong></td>';
						$count_cols ++;
						}
					}
				
				}
		$header .= '</tr>';
		$header .= '<tbody>';
		
		$footer = '</tbody>';
		$footer .= '</table>';
			$i = 1;
			$pages = 1;
		$content = '';	
			$img_ext_array = array('jpg','jpeg','png','tiff','gif','psd');
			$i = 0;
			$sigs_array = array();
			foreach($form_data as $value)
				{
				$content .= '<tr>';
				foreach($columns_array as $column)
					{
					$content .= '<td>';
					$field_value = $value->$column;
					
					$field_value =str_replace('\\','',$field_value);
					
					$field_value = str_replace('\r\n',' ',$field_value);
					$field_value = str_replace('\r',' ',$field_value);
					$field_value = str_replace('\n',' ',$field_value);
					$field_value = str_replace(',',' ',$field_value);
					$field_value = str_replace('
					',' ',$field_value);
					$field_value = str_replace('
					
					',' ',$field_value);
					$field_value = str_replace(chr(10),' ',$field_value);
					$field_value = str_replace(chr(13),' ',$field_value);
					$field_value = str_replace(chr(266),' ',$field_value);
					$field_value = str_replace(chr(269),' ',$field_value);
					$field_value = str_replace(chr(522),' ',$field_value);
					$field_value = str_replace(chr(525),' ',$field_value);
					
					
					if(strstr($field_value,'data:image'))
						{
						$signature = str_replace('data:image/png;base64 ','',$field_value);
						$signature = str_replace('data:image/png;base64,','',$signature);
						$signature = str_replace('data:image/png;base64;','',$signature);
						$sig_rand = rand(0,99999);
						file_put_contents (plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png', base64_decode($signature));
						$content .= '<img width="100px" src="'.plugins_url('/tmp/sig'.$sig_rand.'.png',dirname(__FILE__)).'">';
						$sigs_array[$i] = plugin_dir_path(dirname(__FILE__)).'tmp/sig'.$sig_rand.'.png';
						$i++;
						}
					else
						{
						if(in_array($nf_functions->get_ext($field_value),$img_ext_array))
							$content .= '<img width="65px" src="'.$field_value.'">';
						else
							$content .= $field_value;
						}
					$content .= '</td>';
					
					}
				
				
				$content .= '</tr>';
				$i++;
				if($i==30)
					{
					/*$pdf->AddPage('L', 'A4');
					$set_page_content = $header.$content.$footer;
					$pdf->writeHTML($set_page_content, true, false, true, false, '');
					//$pdf->lastPage();
					$content = '';
					$i = 1;*/
					}
				}
				
				
			
	
	

	$upload_path = wp_upload_dir();
	$set_uploads_dir = $upload_path['path'];
	
	$pdf->setPrintHeader(false);
	$pdf->setPrintFooter(false);
	
	$pdf->AddPage('L', 'A4');
	$set_page_content = $header.$content.$footer;
	$set_page_content = ($database_actions->checkout()) ? $set_page_content : 'Sorry, you need to register this plugin to export entries to PDF. Go to global settings on the dashboard and follow the registration procedure.';
	$pdf->writeHTML($set_page_content, true, false, true, false, '');

	$pdf->Output($set_uploads_dir.'/submission_report.pdf', 'F');
	echo $upload_path['baseurl'].$upload_path['subdir'].'/submission_report.pdf';
	
	foreach($sigs_array as $sigs=>$val){
	unlink($val);
	}
	
	die();
	}



function do_wpautop( $pee, $br = true ) {
    $pre_tags = array();
 
    if ( trim( $pee ) === '' ) {
        return '';
    }
 	
	
	
    // Just to make things a little easier, pad the end.
    $pee = $pee . "\n";
 
    /*
     * Pre tags shouldn't be touched by autop.
     * Replace pre tags with placeholders and bring them back after autop.
     */
    if ( strpos( $pee, '<pre' ) !== false ) {
        $pee_parts = explode( '</pre>', $pee );
        $last_pee  = array_pop( $pee_parts );
        $pee       = '';
        $i         = 0;
 
        foreach ( $pee_parts as $pee_part ) {
            $start = strpos( $pee_part, '<pre' );
 
            // Malformed HTML?
            if ( false === $start ) {
                $pee .= $pee_part;
                continue;
            }
 
            $name              = "<pre wp-pre-tag-$i></pre>";
            $pre_tags[ $name ] = substr( $pee_part, $start ) . '</pre>';
 
            $pee .= substr( $pee_part, 0, $start ) . $name;
            $i++;
        }
 
        $pee .= $last_pee;
    }
    // Change multiple <br>'s into two line breaks, which will turn into paragraphs.
    $pee = preg_replace( '|<br\s*/?>\s*<br\s*/?>|', "\n\n", $pee );
 
    $allblocks = '(?:table|thead|tfoot|caption|col|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|form|map|area|blockquote|address|math|style|p|h[1-6]|hr|fieldset|legend|section|article|aside|hgroup|header|footer|nav|figure|figcaption|details|menu|summary)';
 
    // Add a double line break above block-level opening tags.
    $pee = preg_replace( '!(<' . $allblocks . '[\s/>])!', "\n\n$1", $pee );
 
    // Add a double line break below block-level closing tags.
    $pee = preg_replace( '!(</' . $allblocks . '>)!', "$1\n\n", $pee );
 
    // Add a double line break after hr tags, which are self closing.
    $pee = preg_replace( '!(<hr\s*?/?>)!', "$1\n\n", $pee );
 
    // Standardize newline characters to "\n".
    $pee = str_replace( array( "\r\n", "\r" ), "\n", $pee );
 
    // Find newlines in all elements and add placeholders.
    $pee = wp_replace_in_html_tags( $pee, array( "\n" => ' <!-- wpnl --> ' ) );
 
    // Collapse line breaks before and after <option> elements so they don't get autop'd.
    if ( strpos( $pee, '<option' ) !== false ) {
        $pee = preg_replace( '|\s*<option|', '<option', $pee );
        $pee = preg_replace( '|</option>\s*|', '</option>', $pee );
    }
 
    /*
     * Collapse line breaks inside <object> elements, before <param> and <embed> elements
     * so they don't get autop'd.
     */
    if ( strpos( $pee, '</object>' ) !== false ) {
        $pee = preg_replace( '|(<object[^>]*>)\s*|', '$1', $pee );
        $pee = preg_replace( '|\s*</object>|', '</object>', $pee );
        $pee = preg_replace( '%\s*(</?(?:param|embed)[^>]*>)\s*%', '$1', $pee );
    }

    /*
     * Collapse line breaks inside <audio> and <video> elements,
     * before and after <source> and <track> elements.
     */
    if ( strpos( $pee, '<source' ) !== false || strpos( $pee, '<track' ) !== false ) {
        $pee = preg_replace( '%([<\[](?:audio|video)[^>\]]*[>\]])\s*%', '$1', $pee );
        $pee = preg_replace( '%\s*([<\[]/(?:audio|video)[>\]])%', '$1', $pee );
        $pee = preg_replace( '%\s*(<(?:source|track)[^>]*>)\s*%', '$1', $pee );
    }
  
    // Collapse line breaks before and after <figcaption> elements.
    if ( strpos( $pee, '<figcaption' ) !== false ) {
        $pee = preg_replace( '|\s*(<figcaption[^>]*>)|', '$1', $pee );
        $pee = preg_replace( '|</figcaption>\s*|', '</figcaption>', $pee );
    }
 
    // Remove more than two contiguous line breaks.
    //$pee = preg_replace( "/\n\n+/", "\n\n", $pee );
 
    // Split up the contents into an array of strings, separated by double line breaks.
    //$pees = preg_split( '/\n\s*\n/', $pee, -1, PREG_SPLIT_NO_EMPTY );
 
    // Reset $pee prior to rebuilding.
   // $pee = '';
 
    // Rebuild the content as a string, wrapping every bit with a <p>.
    foreach ( $pees as $tinkle ) {
        $pee .= '' . trim( $tinkle, "\n" ) . "<br/><br/>\n";
    }
 
    // Under certain strange conditions it could create a P of entirely whitespace.
    $pee = preg_replace( '|<p>\s*</p>|', '', $pee );
 
    // Add a closing <p> inside <div>, <address>, or <form> tag if missing.
    $pee = preg_replace( '!<p>([^<]+)</(div|address|form)>!', '<p>$1</p><$2>', $pee );
 
    // If an opening or closing block element tag is wrapped in a <p>, unwrap it.
    $pee = preg_replace( '!<p>\s*(</?' . $allblocks . '[^>]*>)\s*</p>!', '$1', $pee );
 
    // In some cases <li> may get wrapped in <p>, fix them.
    $pee = preg_replace( '|<p>(<li.+?)</p>|', '$1', $pee );
 
    // If a <blockquote> is wrapped with a <p>, move it inside the <blockquote>.
    $pee = preg_replace( '|<p><blockquote([^>]*)>|i', '<blockquote$1><p>', $pee );
    $pee = str_replace( '</blockquote></p>', '</p></blockquote>', $pee );
 
    // If an opening or closing block element tag is preceded by an opening <p> tag, remove it.
    $pee = preg_replace( '!<p>\s*(</?' . $allblocks . '[^>]*>)!', '$1', $pee );
 
    // If an opening or closing block element tag is followed by a closing <p> tag, remove it.
    $pee = preg_replace( '!(</?' . $allblocks . '[^>]*>)\s*</p>!', '$1', $pee );
 
    // Optionally insert line breaks.
    if ( $br ) {
        // Replace newlines that shouldn't be touched with a placeholder.
        $pee = preg_replace_callback( '/<(script|style|svg).*?<\/\\1>/s', '_autop_newline_preservation_helper', $pee );
 
        // Normalize <br>
        $pee = str_replace( array( '<br>', '<br/>' ), '<br />', $pee );
 
        // Replace any new line characters that aren't preceded by a <br /> with a <br />.
        $pee = preg_replace( '|(?<!<br />)\s*\n|', "<br />\n", $pee );
 
        // Replace newline placeholders with newlines.
        $pee = str_replace( '<WPPreserveNewline />', "\n", $pee );
    }
 
    // If a <br /> tag is after an opening or closing block tag, remove it.
    $pee = preg_replace( '!(</?' . $allblocks . '[^>]*>)\s*<br />!', '$1', $pee );
 
    // If a <br /> tag is before a subset of opening or closing block tags, remove it.
    $pee = preg_replace( '!<br />(\s*</?(?:p|li|div|dl|dd|dt|th|pre|td|ul|ol)[^>]*>)!', '$1', $pee );
    $pee = preg_replace( "|\n</p>$|", '</p>', $pee );
 
    // Replace placeholder <pre> tags with their original content.
    if ( ! empty( $pre_tags ) ) {
        $pee = str_replace( array_keys( $pre_tags ), array_values( $pre_tags ), $pee );
    }
 
    // Restore newlines in all elements.
    if ( false !== strpos( $pee, '<!-- wpnl -->' ) ) {
        $pee = str_replace( array( ' <!-- wpnl --> ', '<!-- wpnl -->' ), "\n", $pee );
    }
 
    return $pee;
}